#!/bin/bash

boxdata=()

#
# Handles box coordinates
#
# box_new "chain" "x y width height"
#
# Usage: 
# box_new "POLICIES" "0 0 30 50"
# box_new "INPUT" "5 10 50 50"
#
function box_new () {
    id=$1
    coords=$2

    #
    # Adds the box id
    #
    boxdatalen=${#boxdata[@]}
    boxdata[$boxdatalen]=$1

    #
    # Adds the box coordinates
    #
    boxdatalen=${#boxdata[@]}
    boxdata[$boxdatalen]=$2

}

#
# Get X coordinate of a given box id
#
# Usage:
# x=`box_get_x "POLICIES"`
#
function box_get_x () {
    id=$1

    boxdatalen=${#boxdata[@]}
    i=0

    while [ $i -lt $boxdatalen ]
    do
      if [ "${boxdata[$i]}" == "$1"  ]
      then
	  let "i += 1"
	  echo "${boxdata[$i]}" |cut -d " " -f 1
	  return
      fi
    done

}

#
# Get Y coordinate of a given box id
#
# Usage:
# y=`box_get_y "POLICIES"`
#
function box_get_y () {
    id=$1

    boxdatalen=${#boxdata[@]}
    i=0

    while [ $i -lt $boxdatalen ]
    do
      if [ "${boxdata[$i]}" == "$1"  ]
      then
	  let "i += 1"
	  echo "${boxdata[$i]}" |cut -d " " -f 2
	  return
      fi
    done

}

#
# Get width of a given box id
#
# Usage:
# w=`box_get_width "POLICIES"`
#
function box_get_width () {
    id=$1

    boxdatalen=${#boxdata[@]}
    i=0

    while [ $i -lt $boxdatalen ]
    do
      if [ "${boxdata[$i]}" == "$1"  ]
      then
	  let "i += 1"
	  echo "${boxdata[$i]}" |cut -d " " -f 3
	  return
      fi
    done

}

#
# Get height of a given box id
#
# Usage:
# h=`box_get_height "POLICIES"`
#
function box_get_height () {
    id=$1

    boxdatalen=${#boxdata[@]}
    i=0

    while [ $i -lt $boxdatalen ]
    do
      if [ "${boxdata[$i]}" == "$1"  ]
      then
	  let "i += 1"
	  echo "${boxdata[$i]}" |cut -d " " -f 4
	  return
      fi
    done

}
