#!/bin/bash

#
# Apply the callback "callback_foreach" to all rules
#
# Usage:
# function callback_foreach () {
#     rule=$rule

#     echo $rule |cut -d " " -f 2
# }
# rule_foreach "INPUT" callback_foreach
#

function rule_foreach () {
    chain=$1
    callback=$2

    i=1
    count=`object_chain_count $chain`

    while [ $i -le $count ]
      do
      rule=`object_chain_get_rule_number $chain $i`
      $callback $rule
      let "i += 1"
    done

}

#
# Group all rules
#
function rule_group () {
    chain=$1
    field=$2 # target, proto, opt, source, destination, type, x, y, width, height

    ga=()
    k=0
    l=0
    m=0

    function rule_group_foreach () {
	rule=$rule

	# get content
	content=`echo $rule |cut -d "|" -f 1`
	target=`echo $content |cut -d " " -f 1`
	proto=`echo $content |cut -d " " -f 2`
	opt=`echo $content |cut -d " " -f 3`
	source=`echo $content |cut -d " " -f 4`
	destination=`echo $content |cut -d " " -f 5`

        # get graphics data
	graphics=`echo $rule |cut -d "|" -f 2`
	type=`echo $graphics |cut -d " " -f 1`
	x=`echo $graphics |cut -d " " -f 2`
	y=`echo $graphics |cut -d " " -f 3`
	width=`echo $graphics |cut -d " " -f 4`
	height=`echo $graphics |cut -d " " -f 5`

 	galen=${#ga[@]}

 	if [ "$field" == "source" ]
 	then
	    while [ $k -le $galen ]
	    do
	      echo "a=\"${ga[$k]}\";s=\"$source\""
	      if [ "${ga[$k]}" == "$source" ]
	      then
		  echo "$source IS ALREADY THERE"
	      else
		  echo "$source SHOULD BE ADDED"
		  let "l = $k + 1"
		  ga[$k]="$source"
		  ga[$l]="$content"
	      fi
	      
	      let "k += 2" # field1 @data1 field2 @data2 field3 @data3 ....
 	                   #   0             2             4
	    done
 	fi

    }
    rule_foreach $chain rule_group_foreach

#    echo "ARRAY=${ga[@]}"

}
