#!/bin/bash

# start_svg() {
#     echo "<?xml version=\"1.0\" standalone=\"no\"?>"
#     echo "<!DOCTYPE svg PUBLIC \"-//W3C//DTD SVG 1.1//EN\" \"http://www.w3.org/Graphics/SVG/1.1/DTD/svg11.dtd\">" 
#     echo "<svg width=\"$FW2SVG_SVG_WIDTH\" height=\"$FW2SVG_SVG_HEIGHT\" version=\"1.1\" xmlns=\"http://www.w3.org/2000/svg\">" 
#     echo "  <desc>Firewall configuration</desc>" 
#     echo "" 
# }

# end_svg() {
#     echo "</svg>" 
# }

write_svg_chain () {
    chain=$1

    MARGIN_TOP=20
    let "FW2SVG_HEIGHT += $MARGIN_TOP"
    
    echo "<line x1=\"0\" y1=\"$FW2SVG_HEIGHT\" x2=\"800\" y2=\"$FW2SVG_HEIGHT\" stroke=\"black\" stroke-width=\"1\"/>"

    echo "<text x=\"810\" y=\"$FW2SVG_HEIGHT\" font-family=\"Verdana\" font-size=\"20\" fill=\"blue\" >$chain</text>"

}

write_svg_link () {
    link_start_y=$1
    start_x=$2   
    start_y=$3
    join_x=$4    # where links all join together
    color=$5     # link color

#
# Draw the link
#
    echo "<line x1=\"$join_x\" y1=\"$link_start_y\" x2=\"$join_x\" y2=\"$FW2SVG_HEIGHT\" stroke=\"$color\" stroke-width=\"1\"/>"

#
# Draw the line from the box to the link
#
    echo "<line x1=\"$start_x\" y1=\"$start_y\" x2=\"$join_x\" y2=\"$start_y\" stroke=\"$color\" stroke-width=\"1\"/>"

}

write_svg_box () {
    link_start_y=$1
    chain=$2
    target=$3
    proto=$4
    opt=$5
    source=$6
    destination=$7

    HEIGHT=50
    MARGIN_TOP=10

    MARGIN_BOX_LEFT=5
    MARGIN_TEXT_LEFT=20

    if [ "$chain" == "INPUT" ]
    then
	MARGIN_BOX_LEFT=5
	MARGIN_TEXT_LEFT=20
    fi
    if [ "$chain" == "OUTPUT" ]
    then
	MARGIN_BOX_LEFT=5
	MARGIN_TEXT_LEFT=20
    fi
    

    let "FW2SVG_HEIGHT += $MARGIN_TOP"

    sourcelen=${#source}

    let "WIDTH = $sourcelen * 12"

    if [ $WIDTH -gt $FW2SVG_WIDTH ]
    then
	FW2SVG_WIDTH=$WIDTH
    fi

    if [ "$target" == "ACCEPT" ]
    then
	echo "<rect x=\"$MARGIN_BOX_LEFT\" y=\"$FW2SVG_HEIGHT\" width=\"$WIDTH\" height=\"$HEIGHT\" fill=\"green\" stroke=\"black\" stroke-width=\"1\" />"
    fi
    if [ "$target" == "DROP" ]
    then
	echo "<rect x=\"$MARGIN_BOX_LEFT\" y=\"$FW2SVG_HEIGHT\" width=\"$WIDTH\" height=\"$HEIGHT\" fill=\"red\" stroke=\"black\" stroke-width=\"1\" />"
    fi

    FONT_HEIGHT=$FW2SVG_HEIGHT
    let "FONT_HEIGHT += 25"
    echo "<text x=\"$MARGIN_TEXT_LEFT\" y=\"$FONT_HEIGHT\" font-family=\"Verdana\" font-size=\"15\" fill=\"black\" >$source</text>"

    let "FW2SVG_HEIGHT += $HEIGHT"

#
# Now that the box has been drawn, we set up the link
#
    let "box_right_x = $MARGIN_BOX_LEFT + $WIDTH"
    let "box_start_y = $FW2SVG_HEIGHT - $HEIGHT + 25"
    let "link_start_y += 10"
    

   if [ "$destination" == "anywhere" ]
   then
       join=500
       write_svg_link $link_start_y $box_right_x $box_start_y $join "black" 
   fi


}

write_svg_machine () {
    
    chain=$1

    let "X = $FW2SVG_WIDTH + 500"

    let "FW2SVG_HEIGHT_AVERAGE = $FW2SVG_HEIGHT - 500"

    if [ "$chain" == "INPUT" ]
    then
	echo "<rect x=\"$X\" y=\"$FW2SVG_HEIGHT_AVERAGE\" width=\"100\" height=\"100\" fill=\"black\" stroke=\"black\" stroke-width=\"1\" />"
    fi

#     if [ "$chain" == "OUTPUT" ]
#     then
#     fi
    

}